/*
	La version un peu plus dveloppe de l'applet "maison"
	qui dessine maintenant des ovales, des rectangles
	et des lignes...
	Utilise maintenant un design pattern factory pour
	construire des objets...
	C'est toujours trs joli pour les enfants...

	(C) J. Ferber - Juillet 2000
*/
package maison;

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;

/** La classe Ligne. Les lignes ne sont pas des RectangularFigure!
*/

class Ligne extends Figure {

       int x2, y2;

	void dessiner(Graphics g){
		g.setColor(getColor(couleur));
		g.drawLine(x,y,x2,y2);
	}

        Ligne(){}

        void setPos2(int x1, int y1){
             x2=x1;
             y2=y1;
        }

 		void drawBuild(Graphics g, int ox, int oy, int nx, int ny){
  			g.drawLine(ox,oy,nx,ny);
  		}

        Figure cloneFig(int x0, int y0, int x1, int y1, int coul){
          Ligne f=null;
          try{
            f = (Ligne) clone();
          } catch(CloneNotSupportedException e){
              System.out.println("Clone impossible : "+ e.getMessage());
          }
            if (f != null){
               f.setPos(x0,y0);
               f.setColor(coul);
               f.setPos2(x1,y1);
            }
            return f;
        }
        /** les lignes ne peuvent pas tre bouges...
         */
    	void translate(Graphics g, int dx, int dy){}

		boolean contains(Point p){
        	return(false);
        }

  	public void saveBody(PrintWriter fos){
		super.saveBody(fos);
		fos.print(", "+x2+", "+y2);
	}

	public void parse(StreamTokenizer st, DrawingPane d) {
		super.parse(st,d);
    	try {
       		st.nextToken(); x2 = (int) st.nval;
    		st.nextToken(); y2 = (int) st.nval;
       }
       catch (IOException e) {
            	System.err.println("parse: " + e);
       }
    }
}